## net.sf.saxon.value
Class TimeValue

    java.lang.Object
      |
      +--net.sf.saxon.value.Value
            |
            +--net.sf.saxon.value.AtomicValue
                  |
                  +--net.sf.saxon.value.CalendarValue
                        |
                        +--net.sf.saxon.value.TimeValue

All Implemented Interfaces:
  java.lang.Comparable, Expression, Item, java.io.Serializable

public final class TimeValue
extends CalendarValue
implements java.lang.Comparable

A value of type xs:time

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.value.CalendarValue
`calendar, zoneSpecified`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`TimeValue(java.lang.CharSequence s)` Constructor: create a dateTime value from a supplied string, in ISO 8601 format
`TimeValue(java.util.GregorianCalendar calendar, boolean tzSpecified)` Constructor: create a time value given a Java calendar object

Method Summary
`CalendarValue` `add(DurationValue duration)` Add a duration to a dateTime
`int` `compareTo(java.lang.Object other)` Compare the value to another dateTime value
`AtomicValue` `convert(int requiredType, XPathContext context)` Convert to target data type
`java.lang.Object` `convertToJava(java.lang.Class target, Configuration config, XPathContext context)` Convert to Java object (for passing to external functions)
`boolean` `equals(java.lang.Object other)`
`AtomicValue` `getComponent(int component)` Get a component of the value.
`ItemType` `getItemType()` Determine the data type of the exprssion
`java.lang.String` `getStringValue()` Convert to string
`int` `hashCode()`
`CalendarValue` `removeTimezone()` Return a dateTime with the same localized value, but without the timezone component
`CalendarValue` `setTimezone(SecondsDurationValue tz)` Return a date, time, or dateTime with the same normalized value, but in a different timezone
`SecondsDurationValue` `subtract(CalendarValue other)` Determine the difference between two points in time, as a duration
`DateTimeValue` `toDateTime()` Convert to a DateTime value (used internally only: the date components should be ignored)

Methods inherited from class net.sf.saxon.value.AtomicValue
`convert, display, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getImplementationMethod, getPrimitiveValue, getTypedValue, iterate, process, toString`

Methods inherited from class net.sf.saxon.value.Value
`analyze, asItem, asValue, collapseWhitespace, convertJavaObjectToXPath, getDependencies, getParentExpression, getSpecialProperties, inverse, iterateSubExpressions, normalizeWhitespace, promote, simplify, stringToNumber, trimWhitespace`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### TimeValue

    public TimeValue(java.util.GregorianCalendar calendar,
                     boolean tzSpecified)

  Constructor: create a time value given a Java calendar object

Parameters:
  `calendar` - holds the date and time
  `tzSpecified` - indicates whether the timezone is specified

### TimeValue

    public TimeValue(java.lang.CharSequence s)
              throws XPathException

  Constructor: create a dateTime value from a supplied string, in ISO 8601 format

Method Detail

### convert

    public AtomicValue convert(int requiredType,
                               XPathContext context)
                        throws XPathException

  Convert to target data type

  Specified by:
    `convert` in class `AtomicValue`
  Parameters:
    `requiredType` - an integer identifying the required atomic type
    `context` - the evaluation context. Used primarily for error reporting, since nearly all type conversions are context-independent. The value may be null if the context is not known.
  Returns:
    an AtomicValue, a value of the required type
  Throws:
    `XPathException` - if the conversion is not possible

### getStringValue

    public java.lang.String getStringValue()

  Convert to string

  Specified by:
    `getStringValue` in interface `Item`
  Specified by:
    `getStringValue` in class `AtomicValue`
  Returns:
    ISO 8601 representation, in the localized timezone (the timezone held within the value).

### toDateTime

    public DateTimeValue toDateTime()

  Convert to a DateTime value (used internally only: the date components should be ignored)

### getItemType

    public ItemType getItemType()

  Determine the data type of the exprssion

  Specified by:
    `getItemType` in interface `Expression`
  Returns:
    Type.TIME,

### removeTimezone

    public CalendarValue removeTimezone()
                                 throws XPathException

  Return a dateTime with the same localized value, but without the timezone component

  Specified by:
    `removeTimezone` in class `CalendarValue`
  Returns:
    the result of removing the timezone
  Throws:
    `XPathException`

### setTimezone

    public CalendarValue setTimezone(SecondsDurationValue tz)
                              throws XPathException

  Return a date, time, or dateTime with the same normalized value, but in a different timezone

  Specified by:
    `setTimezone` in class `CalendarValue`
  Returns:
    the date/time in the new timezone
  Throws:
    `XPathException`

### convertToJava

    public java.lang.Object convertToJava(java.lang.Class target,
                                          Configuration config,
                                          XPathContext context)
                                   throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `AtomicValue`
  Parameters:
    `target` - The class required by the external function
    `config` - The configuration (needed for access to schema information)
  Returns:
    an object of the target class
    `XPathException`

### getComponent

    public AtomicValue getComponent(int component)
                             throws XPathException

  Get a component of the value. Returns null if the timezone component is requested and is not present.

  Overrides:
    `getComponent` in class `AtomicValue`
    `XPathException`

### compareTo

    public int compareTo(java.lang.Object other)

  Compare the value to another dateTime value

  Specified by:
    `compareTo` in interface `java.lang.Comparable`
  Parameters:
    `other` - The other dateTime value
  Returns:
    negative value if this one is the earler, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
  Throws:
    `java.lang.ClassCastException` - if the other value is not a DateTimeValue (the parameter is declared as Object to satisfy the Comparable interface)

### equals

    public boolean equals(java.lang.Object other)

  Overrides:
    `equals` in class `java.lang.Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `java.lang.Object`

### add

    public CalendarValue add(DurationValue duration)
                      throws XPathException

  Add a duration to a dateTime

  Specified by:
    `add` in class `CalendarValue`
  Parameters:
    `duration` - the duration to be added (may be negative)
  Returns:
    the new date
  Throws:
    `XPathException` - if the duration is an xs:duration, as distinct from a subclass thereof

### subtract

    public SecondsDurationValue subtract(CalendarValue other)
                                  throws XPathException

  Determine the difference between two points in time, as a duration

  Overrides:
    `subtract` in class `CalendarValue`
  Parameters:
    `other` - the other point in time
  Returns:
    the duration as an xdt:dayTimeDuration
  Throws:
    `XPathException` - for example if one value is a date and the other is a time